## ICalProperty ICalProperty |

## Functions

ICalProperty * | i_cal_property_new ()
ICalProperty * | i_cal_property_clone ()
ICalProperty * | i_cal_property_new_from_string ()
gchar * | i_cal_property_as_ical_string ()
void | i_cal_property_free ()
ICalPropertyKind | i_cal_property_isa ()
gint | i_cal_property_isa_property ()
void | i_cal_property_add_parameter ()
void | i_cal_property_take_parameter ()
void | i_cal_property_set_parameter ()
void | i_cal_property_set_parameter_from_string ()
gchar * | i_cal_property_get_parameter_as_string ()
void | i_cal_property_remove_parameter_by_kind ()
void | i_cal_property_remove_parameter_by_name ()
void | i_cal_property_remove_parameter_by_ref ()
gint | i_cal_property_count_parameters ()
ICalParameter * | i_cal_property_get_first_parameter ()
ICalParameter * | i_cal_property_get_next_parameter ()
void | i_cal_property_set_value ()
void | i_cal_property_take_value ()
void | i_cal_property_set_value_from_string ()
ICalValue * | i_cal_property_get_value ()
gchar * | i_cal_property_get_value_as_string ()
void | i_cal_value_set_parent ()
ICalProperty * | i_cal_value_get_parent ()
void | i_cal_parameter_set_parent ()
ICalProperty * | i_cal_parameter_get_parent ()
void | i_cal_property_set_x_name ()
const gchar * | i_cal_property_get_x_name ()
gchar * | i_cal_property_get_property_name ()
ICalValueKind | i_cal_parameter_value_to_value_kind ()
ICalValueKind | i_cal_property_kind_to_value_kind ()
ICalPropertyKind | i_cal_value_kind_to_property_kind ()
const gchar * | i_cal_property_kind_to_string ()
ICalPropertyKind | i_cal_property_kind_from_string ()
gboolean | i_cal_property_kind_is_valid ()
ICalPropertyMethod | i_cal_property_method_from_string ()
const gchar * | i_cal_property_method_to_string ()
gchar * | i_cal_property_enum_to_string ()
gint | i_cal_property_kind_and_string_to_enum ()
ICalPropertyStatus | i_cal_property_status_from_string ()
const gchar * | i_cal_property_status_to_string ()
gint | i_cal_property_kind_has_property ()

## Types and Values

| ICalProperty
struct | ICalPropertyClass

## Object Hierarchy

        GObject
        ╰── ICalObject
            ╰── ICalProperty

## Description

## Functions

### i_cal_property_new ()

    ICalProperty *
    i_cal_property_new (ICalPropertyKind kind);

Create a ICalProperty of the target type.

#### Parameters

kind | The kind of ICalProperty to be created. |

#### Returns

The newly created ICalProperty with the type `kind` .

[transfer full]

Since: 1.0

### i_cal_property_clone ()

    ICalProperty *
    i_cal_property_clone (ICalProperty *prop);

Deeply clone a ICalProperty.

#### Parameters

prop | The ICalProperty to be cloned. |

#### Returns

The newly created ICalProperty deeply cloned from `prop` .

[transfer full]

Since: 1.0

### i_cal_property_new_from_string ()

    ICalProperty *
    i_cal_property_new_from_string (const gchar *str);

Create a ICalProperty from a string.

#### Parameters

str | The string used to construct a ICalProperty. |

#### Returns

The newly created ICalProperty from `str` .

[transfer full]

Since: 1.0

### i_cal_property_as_ical_string ()

    gchar *
    i_cal_property_as_ical_string (ICalProperty *prop);

Convert a ICalProperty to a string representation.

#### Parameters

prop | The ICalProperty to be converted. |

#### Returns

The string representation of `prop` .

[transfer full]

Since: 1.0

### i_cal_property_free ()

    void
    i_cal_property_free (ICalProperty *prop);

Free a ICalProperty.

[skip]

#### Parameters

prop | The ICalProperty to be freed. | [transfer full]

Since: 1.0

### i_cal_property_isa ()

    ICalPropertyKind
    i_cal_property_isa (ICalProperty *property);

Get the kind of ICalProperty.

#### Parameters

property | The ICalProperty which type is to be determined. |

#### Returns

The type of ICalProperty.

Since: 1.0

### i_cal_property_isa_property ()

    gint
    i_cal_property_isa_property (ICalProperty *property);

Check whether the native part of ICalProperty is of the type icalproperty.

#### Parameters

property | The object whose native part to be checked. |

#### Returns

1 if the native part of `property` is of the type icalproperty, 0 if not.

Since: 1.0

### i_cal_property_add_parameter ()

    void
    i_cal_property_add_parameter (ICalProperty *prop,
                                  ICalParameter *parameter);

Add a ICalParameter into the ICalProperty. It behaves like set the copy of the ICalParameter. Upon completion the native part of ICalParameter will be set to NULL.

#### Parameters

prop | The ICalProperty to be set. |
parameter | The parameter to be added into `prop` . | [transfer none]

Since: 1.0

### i_cal_property_take_parameter ()

    void
    i_cal_property_take_parameter (ICalProperty *prop,
                                   ICalParameter *parameter);

Add the `parameter` into the `prop` and free the `parameter` .

[skip]

#### Parameters

prop | The ICalProperty to be set. |
parameter | The parameter to be added into `prop` . | [transfer full]

Since: 1.0

### i_cal_property_set_parameter ()

    void
    i_cal_property_set_parameter (ICalProperty *prop,
                                  ICalParameter *parameter);

Set a ICalParameter into the ICalProperty. It behaves like set the copy of the ICalParameter. Upon completion the native part of ICalParameter will be set to NULL.

#### Parameters

prop | The ICalProperty to be set. |
parameter | The parameter to be set into `prop` . | [transfer full]

Since: 1.0

### i_cal_property_set_parameter_from_string ()

    void
    i_cal_property_set_parameter_from_string
                                   (ICalProperty *prop,
                                    const gchar *name,
                                    const gchar *value);

Set the ICalProperty with the parameter defined by the name and value.

#### Parameters

prop | The ICalProperty to be set. |
name | The name of the parameter. |
value | The value of the parameter. |

Since: 1.0

### i_cal_property_get_parameter_as_string ()

    gchar *
    i_cal_property_get_parameter_as_string
                                   (ICalProperty *prop,
                                    const gchar *name);

Get the string representation of the target parameter in the ICalProperty.

#### Parameters

prop | The ICalProperty to be queried. |
name | The name of the target parameter. |

#### Returns

The string representation of the parameter.

[transfer full]

Since: 1.0

### i_cal_property_remove_parameter_by_kind ()

    void
    i_cal_property_remove_parameter_by_kind
                                   (ICalProperty *prop,
                                    ICalParameterKind kind);

Remove the target kind of the parameters in the ICalProperty.

#### Parameters

prop | The ICalProperty to be manipulated. |
kind | The ICalParameterKind to be removed. |

Since: 1.0

### i_cal_property_remove_parameter_by_name ()

    void
    i_cal_property_remove_parameter_by_name
                                   (ICalProperty *prop,
                                    const gchar *name);

Remove parameter in the ICalProperty by name.

#### Parameters

prop | The ICalProperty to be manipulated. |
name | The name of the parameter to be removed. |

Since: 1.0

### i_cal_property_remove_parameter_by_ref ()

    void
    i_cal_property_remove_parameter_by_ref
                                   (ICalProperty *prop,
                                    ICalParameter *param);

Remove the parameter in the ICalProperty by ref.

#### Parameters

prop | The ICalProperty to be manipulated. |
param | The ICalParameter to be removed. |

Since: 1.0

### i_cal_property_count_parameters ()

    gint
    i_cal_property_count_parameters (const ICalProperty *prop);

Count the parameters in the ICalProperty.

#### Parameters

prop | The ICalProperty to be checked. |

#### Returns

The count of the parameters in the ICalProperty.

Since: 1.0

### i_cal_property_get_first_parameter ()

    ICalParameter *
    i_cal_property_get_first_parameter (ICalProperty *prop,
                                        ICalParameterKind kind);

Get the first ICalParameter from the parent ICalProperty.

#### Parameters

prop | The ICalProperty to be queried. |
kind | The target kind of ICalParameter to be retrieved. |

#### Returns

The first ICalParameter of `prop` .

[transfer full]

Since: 1.0

### i_cal_property_get_next_parameter ()

    ICalParameter *
    i_cal_property_get_next_parameter (ICalProperty *prop,
                                       ICalParameterKind kind);

Get the next ICalParameter from the parent ICalProperty.

#### Parameters

prop | The ICalProperty to be queried. |
kind | The target kind of ICalParameter to be retrieved. |

#### Returns

The next ICalParameter of `prop` .

[transfer full]

Since: 1.0

### i_cal_property_set_value ()

    void
    i_cal_property_set_value (ICalProperty *prop,
                              ICalValue *value);

Set the ICalProperty with the ICalValue.

#### Parameters

prop | The target ICalProperty. |
value | The ICalValue will be set as the property of `prop` . |

Since: 1.0

### i_cal_property_take_value ()

    void
    i_cal_property_take_value (ICalProperty *prop,
                               ICalValue *value);

Set the `prop` with the `value` and unrefs the `value` .

[skip]

#### Parameters

prop | The target ICalProperty. |
value | The ICalValue will be set as the property of `prop` . | [transfer full]

Since: 1.0

### i_cal_property_set_value_from_string ()

    void
    i_cal_property_set_value_from_string (ICalProperty *prop,
                                          const gchar *value,
                                          const gchar *kind);

Set the ICalProperty with the ICalValue constructed from string.

#### Parameters

prop | The ICalProperty to be set. |
value | The value used to construct the ICalValue. |
kind | The kind used to construct the ICalValue. |

Since: 1.0

### i_cal_property_get_value ()

    ICalValue *
    i_cal_property_get_value (const ICalProperty *prop);

Get the ICalValue of ICalProperty.

#### Parameters

prop | The ICalProperty to be queried. |

#### Returns

The ICalValue of `prop` .

[transfer full]

Since: 1.0

### i_cal_property_get_value_as_string ()

    gchar *
    i_cal_property_get_value_as_string (const ICalProperty *prop);

Get the string representation of the value in ICalProperty.

#### Parameters

prop | The ICalProperty to be queried. |

#### Returns

The string representation of the value of the ICalProperty.

[transfer full]

Since: 1.0

### i_cal_value_set_parent ()

    void
    i_cal_value_set_parent (ICalValue *value,
                            ICalProperty *property);

Set the parent property of a value.

#### Parameters

value | The child ICalValue |
property | The parent ICalProperty. | [nullable]

Since: 2.0

### i_cal_value_get_parent ()

    ICalProperty *
    i_cal_value_get_parent (ICalValue *value);

Get the parent ICalProperty of the specified ICalValue.

#### Parameters

value | The child ICalValue |

#### Returns

The parent ICalProperty.

[transfer full][nullable]

Since: 3.0

### i_cal_parameter_set_parent ()

    void
    i_cal_parameter_set_parent (ICalParameter *param,
                                ICalProperty *property);

Set the parent ICalProperty of an ICalParameter.

#### Parameters

param | The child ICalParameter |
property | The parent ICalProperty. | [nullable]

Since: 3.0

### i_cal_parameter_get_parent ()

    ICalProperty *
    i_cal_parameter_get_parent (ICalParameter *param);

Get the parent ICalProperty of the specified ICalParameter.

#### Parameters

param | The child ICalParameter |

#### Returns

The parent ICalProperty.

[transfer full][nullable]

Since: 3.0

### i_cal_property_set_x_name ()

    void
    i_cal_property_set_x_name (ICalProperty *prop,
                               const gchar *name);

Set the name of x property for the ICalProperty.

#### Parameters

prop | A ICalProperty |
name | The name string. |

Since: 1.0

### i_cal_property_get_x_name ()

    const gchar *
    i_cal_property_get_x_name (ICalProperty *prop);

Get the name of x property.

#### Parameters

prop | A ICalProperty. |

#### Returns

The name of x property.

[nullable]

Since: 1.0

### i_cal_property_get_property_name ()

    gchar *
    i_cal_property_get_property_name (const ICalProperty *prop);

Get the property name of ICalProperty.

#### Parameters

prop | A ICalProperty. |

#### Returns

Property name of ICalProperty.

[transfer full]

Since: 1.0

### i_cal_parameter_value_to_value_kind ()

    ICalValueKind
    i_cal_parameter_value_to_value_kind (ICalParameterValue value);

Convert the ICalParameterValue to ICalValueKind.

#### Parameters

value | A ICalParameterValue. |

#### Returns

ICalValueKind

Since: 1.0

### i_cal_property_kind_to_value_kind ()

    ICalValueKind
    i_cal_property_kind_to_value_kind (ICalPropertyKind kind);

Convert the ICalPropertyKind to ICalValueKind.

#### Parameters

kind | A ICalPropertyKind. |

#### Returns

The ICalValueKind

Since: 1.0

### i_cal_value_kind_to_property_kind ()

    ICalPropertyKind
    i_cal_value_kind_to_property_kind (ICalValueKind kind);

Convert a ICalValueKind to a ICalPropertyKind.

#### Parameters

kind | A ICalValueKind |

#### Returns

The ICalPropertyKind.

Since: 1.0

### i_cal_property_kind_to_string ()

    const gchar *
    i_cal_property_kind_to_string (ICalPropertyKind kind);

Convert the ICalPropertyKind to a string.

#### Parameters

kind | A ICalPropertyKind. |

#### Returns

The string representation of `kind` .

Since: 1.0

### i_cal_property_kind_from_string ()

    ICalPropertyKind
    i_cal_property_kind_from_string (const gchar *string);

Convert the string to ICalPropertyKind.

#### Parameters

string | A string representing ICalPropertyKind. |

#### Returns

The ICalPropertyKind.

Since: 1.0

### i_cal_property_kind_is_valid ()

    gboolean
    i_cal_property_kind_is_valid (const ICalPropertyKind kind);

Check whether ICalPropertyKind is valid.

#### Parameters

kind | The ICalPropertyKind |

#### Returns

1 if valid, 0 if not.

Since: 1.0

### i_cal_property_method_from_string ()

    ICalPropertyMethod
    i_cal_property_method_from_string (const gchar *str);

Convert the string to ICalPropertyKind.

#### Parameters

str | A string. |

#### Returns

The ICalPropertyMethod.

Since: 1.0

### i_cal_property_method_to_string ()

    const gchar *
    i_cal_property_method_to_string (ICalPropertyMethod method);

Convert the ICalPropertyMethod to string.

#### Parameters

method | The ICalPropertyMethod. |

#### Returns

The string representation of ICalPropertyMethod.

Since: 1.0

### i_cal_property_enum_to_string ()

    gchar *
    i_cal_property_enum_to_string (gint e);

Convert the enum to string.

#### Parameters

e | The enum to be converted. |

#### Returns

The string representation of `e` .

[transfer full]

Since: 1.0

### i_cal_property_kind_and_string_to_enum ()

    gint
    i_cal_property_kind_and_string_to_enum
                                   (const gint kind,
                                    const gchar *str);

Convert a integer and string into an enum.

#### Parameters

kind | The kind. |
str | A string. |

#### Returns

The enum.

Since: 1.0

### i_cal_property_status_from_string ()

    ICalPropertyStatus
    i_cal_property_status_from_string (const gchar *str);

Convert the string to ICalPropertyKind.

#### Parameters

str | A string. |

#### Returns

The ICalPropertyStatus.

Since: 1.0

### i_cal_property_status_to_string ()

    const gchar *
    i_cal_property_status_to_string (ICalPropertyStatus method);

Convert the ICalPropertyStatus to string.

#### Parameters

method | The ICalPropertyStatus. |

#### Returns

The string representation of ICalPropertyStatus.

Since: 1.0

### i_cal_property_kind_has_property ()

    gint
    i_cal_property_kind_has_property (ICalPropertyKind kind,
                                      gint e);

Check whether the enum belongs to the ICalPropertyKind.

#### Parameters

kind | A ICalPropertyKind |
e | The enum to be checked. |

#### Returns

1 if yes, 0 if not.

Since: 1.0

## Types and Values

### ICalProperty

    typedef struct _ICalProperty ICalProperty;

This is the ICalProperty instance.

### struct ICalPropertyClass

    struct ICalPropertyClass {
    };

This is the ICalProperty class.